/* --------------------------------------------------------
   ivvO
                                    2003/07/28
                                         S.Mio
*/

#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* Ֆ */
unsigned char nanpleTable[9][9] = {
    {0, 0, 8, 0, 0, 0, 0, 0, 0,},
    {1, 0, 0, 6, 0, 0, 3, 0, 0,},
    {0, 0, 0, 5, 1, 0, 9, 0, 0,},
    {0, 0, 1, 0, 0, 0, 4, 0, 0,},
    {0, 6, 0, 0, 8, 7, 0, 0, 0,},
    {0, 0, 0, 0, 3, 0, 5, 0, 2,},
    {0, 0, 9, 0, 0, 4, 0, 0, 0,},
    {0, 7, 0, 0, 0, 9, 0, 4, 0,},
    {5, 3, 0, 0, 0, 0, 0, 0, 0,},
};

/* Ɨpe[u */
typedef struct {
    unsigned char hitno;              /* m肵                */
    unsigned char checknolist[9 + 1]; /* ̌                  */
                                      /* vf0Ȃ\鐔 */
} t_nanpleItem;
t_nanpleItem nanpleWork[9][9];


/* ̒lݒpe[u */
typedef struct {
    t_nanpleItem saveitem[9][9];        /* Ֆʂ̕ۑ       */
    int x,y;                            /* ̒l߂ʒu */
    unsigned char checknolist[9 + 1];   /* ̒ľ       */
} t_nanpleBacktrackItem;

/* ̒l̃e[u */
t_nanpleBacktrackItem nanpleBactrackWork[9 * 9 + 1];

/* ̒l̈ʒuJE^ */
int backtrackCount = 0;


/* -------------------------------------------------------- */
/* Ֆʂ̃f[^nanpleWork̐ݒ */
void init(void)
{
    int x, y, c;
 
    for (y = 0; y < 9; y++) {
        for (x = 0; x < 9; x++) {
            if (nanpleTable[y][x]) {
                /* e[um肵Ă鐔ݒ */
                /* 萔x,ytɂȂ̂Łc      */
                nanpleWork[x][y].hitno = nanpleTable[y][x];
            } else {
                /* ̈ʒű󂫏 */
                nanpleWork[x][y].hitno = 0;
            }
            for (c = 1; c <= 9; c++) {
                nanpleWork[x][y].checknolist[c] = 0;
            }
        }
    }
    backtrackCount = 0;
}

/* ՖʂSmF */
int total_hitnocheck(void)
{
    int x, y, c;
 
    for (y = 0; y < 9; y++) {
        for (x = 0; x < 9; x++) {
            /* 1łm肵ĂȂ܂ݒ */
            if (nanpleWork[x][y].hitno == 0)
                return 0;
        }
    }
    return 1;
}

/* Ֆʂ[ǂȂĂ邩SmF */
int total_rulecheck(void)
{
    /* ƂȂƐ̌₪0ɂȂ}X
       (ǂ̕ʒuɂ̂0ɂȂ)
       ôŁC𒲂ׂ */
    int x, y, c, count;
    
    for (y = 0; y < 9; y++) {
        for (x = 0; x < 9; x++) {
            if (nanpleWork[x][y].hitno != 0)
                continue;
            count = 0;
            for (c = 1; c <= 9; c++) {
                if (nanpleWork[x][y].checknolist[c] != 0)
                    count++;
            }
            if (count == 9)
                return 1;
        }
    }
    return 0;
}

/* Ֆʂ̐̌ɕωȂǂmF */
/* ω1CωȂ0 */
int ischange(void)
{
    static t_nanpleItem nanpleWorkBackup[9][9];
    int x, y, c, result = 0;
    
    for (y = 0; y < 9; y++) {
        for (x = 0; x < 9; x++) {
            for (c = 1; c <= 9; c++) {
                if ((nanpleWork[x][y].checknolist[c] != 0) &&
                    (nanpleWorkBackup[x][y].checknolist[c] == 0)) {
                    result = 1;
                }
            }
            if (nanpleWorkBackup[x][y].hitno != nanpleWork[x][y].hitno) {
                result = 1;
            }
        }
    }
    memcpy(nanpleWorkBackup, nanpleWork, sizeof(nanpleWorkBackup));
    return result;
}


/* -------------------------------------------------------- */
/* ܂gĂȂ̒l */
int search_bactrack_hitno(int pos)
{
    int c;
    
    if (backtrackCount == 0)
        return 0;

    for (c = 1; c <= 9; c++) {
        if (nanpleBactrackWork[pos].checknolist[c] == 0) {
            return c;
        }
    }
    return 0;
}

/* ̒lm肵ƂĐݒ肷 */
int set_bactrack_hitno(void)
{
    int x, y, c, pos;
    int result = 0;
    
    if (backtrackCount == 0)
        return 0;

    pos = backtrackCount - 1;
    c = search_bactrack_hitno(pos);
    if (c != 0) {
        x = nanpleBactrackWork[pos].x;
        y = nanpleBactrackWork[pos].y;
        nanpleBactrackWork[pos].checknolist[c] = 1;
        nanpleWork[x][y].hitno = c;
    }
    return result;
}

/* ̒lnanpleBactrackWorkz֐ݒ */
void set_bactrack_item(int x, int y)
{
    int c;
    
    /* f[^̑Ҕ */
    memcpy(nanpleBactrackWork[backtrackCount].saveitem, 
           nanpleWork, sizeof(nanpleBactrackWork[backtrackCount].saveitem));
    nanpleBactrackWork[backtrackCount].x = x;
    nanpleBactrackWork[backtrackCount].y = y;
    memcpy(nanpleBactrackWork[backtrackCount].checknolist, 
           nanpleWork[x][y].checknolist, 
           sizeof(nanpleWork[x][y].checknolist));

    /* JE^1i߂ */
    backtrackCount++;
}

/* ̒lݒ */
void set_tmpno(void)
{
    int x, y, c, count;
    int hitx, hity, hitcount, hitno;
    
    /* Ƃ̌₪Ȃ}Ẍʒu𓾂 */
    hitcount = 9;
    hitx = -1;
    hity = -1;
    for (y = 0; y < 9; y++) {
        for (x = 0; x < 9; x++) {
            if (nanpleWork[x][y].hitno != 0)
                continue;
            count = 0;
            for (c = 1; c <= 9; c++) {
                if (nanpleWork[x][y].checknolist[c] == 0)
                    count++;
            }
            if (count < hitcount) {
                hitx = x;
                hity = y;
                hitcount = count;
            }
        }
    }
    if (hitx == -1) {
        /* Ȃ߂ */
        return;
    }
    
    /* ̒lpzɗvfݒ */
    set_bactrack_item(hitx, hity);

    /* ̒lm肵ƂĐݒ肷 */
    set_bactrack_hitno();
}

/* ݒ肵̒l߂ */
void change_tmpno(void)
{
    int result;

    if (backtrackCount == 0)
        return;

    while(!search_bactrack_hitno(backtrackCount - 1)) {
        /* ̌g؂̂1߂ */
        backtrackCount--;
        if (backtrackCount == 0)
            return;
    }
    if (backtrackCount) {
        /* Ֆʂ̕ */
        memcpy(nanpleWork, nanpleBactrackWork[backtrackCount - 1].saveitem, 
          sizeof(nanpleBactrackWork[backtrackCount - 1].saveitem));
        
        /* Vlm */
        set_bactrack_hitno();
    }
}


/* -------------------------------------------------------- */
/* w肳ꂽ̈ɂm肵znolistɐݒ肷 */
/* 
   top:     Tn߂c̈ʒu
   left:    Tn߂鉡̈ʒu
   width:   T̉
   height:  Tc̉
   nolist:  ̐߂z
*/
void set_checkno_fromareahitno(int left, int top,
  int width, int height, unsigned char *nolist)
{
    int x, y, c;
    
    for (y = 0; y < height; y++) {
        for (x = 0; x < width; x++) {
            if (nanpleWork[left + x][top + y].hitno) {
                c = nanpleWork[left + x][top + y].hitno;
                nolist[c] = 1;
            }
        }
    }
}

/* w肳ꂽ̈ɂ鐔̌ƔrĐm肷 */
/* 
   item:    ݌Ă}X
   top:     Tn߂c̈ʒu
   left:    Tn߂鉡̈ʒu
   width:   T̉
   height:  Tc̉
   nolist:  ̐߂z
*/
void set_hitno_fromareacheckno(t_nanpleItem *item,
  int left, int top, int width, int height, int no)
{
    int x, y, hitcount;
    
    /* łɒlm肵Ă̂Ȃ珈Ȃ */
    if (item->hitno != 0)
        return;
    hitcount = 0;
    for (y = 0; y < height; y++) {
        for (x = 0; x < width; x++) {
            if ((nanpleWork[left + x][top + y].hitno) ||
                (nanpleWork[left + x][top + y].checknolist[no] != 0)) {
                hitcount++;
            }
        }
    }
    /* 8ӏĂ̂Ȃlm肷 */
    if (hitcount == 8) {
        item->hitno = no;
    }
}


/* -------------------------------------------------------- */
/* ݌Ăn_ɂāCՖʂ̂CcCC3~3
   ׂĂŊm肵Ă̂S   */
void item_set_checkno_fromareahitno(int x, int y)
{
    /* c̊m肵Ă̂ݒ */
    set_checkno_fromareahitno(x, 0, 1, 9, 
      nanpleWork[x][y].checknolist);

    /* ̊m肵Ă̂ݒ */
    set_checkno_fromareahitno(0, y, 9, 1, 
      nanpleWork[x][y].checknolist);

    /* 3x3̃}XڂŊm肵Ă̂ݒ */
    set_checkno_fromareahitno((x / 3) * 3, (y / 3) * 3, 3, 3, 
      nanpleWork[x][y].checknolist);
}

/* ݌Ăn_ɂāCꂼ̕ɌƂȂĂ鐔𓾂 */
void item_set_hitno_fromareacheckno(int x, int y)
{
    int result, c;

    for (c = 1; c <= 9; c++) {
        if (nanpleWork[x][y].checknolist[c] == 0) {

            /* c̐̌𓾂Ċmł邩mF */
            set_hitno_fromareacheckno(&nanpleWork[x][y], 
              x, 0, 1, 9, c);

            /* ̐̌𓾂Ċmł邩mF */
            set_hitno_fromareacheckno(&nanpleWork[x][y], 
              0, y, 9, 1, c);

            /* 3x3̈̃}XڂŌ𓾂Ċmł邩mF */
            set_hitno_fromareacheckno(&nanpleWork[x][y], 
              (x / 3) * 3, (y / 3) * 3, 3, 3, c);
        }
    }
}

/* ݌Ăn_̐̌mł邩mF */
int item_check_checknolist(int x, int y)
{
    int c, nocount, hitno;

    /* łɊm肵Ă */
    if (nanpleWork[x][y].hitno)
        return 0;

    /* ̐𐔂 */
    nocount = 0;
    for (c = 1; c <= 9; c++) {
        if (nanpleWork[x][y].checknolist[c] == 0) {
            nocount++;
            hitno = c;
        }
    }
    
    /* ₪1ɂȂlm */
    if (nocount == 1) {
        nanpleWork[x][y].hitno = hitno;
        return 1;
    }
    return 0;
}


/* -------------------------------------------------------- */
/* Ɨpf[^̕\ */
void work_dump(void)
{
    int x, y, c, no;

    for (y = 0; y < 9; y++) {
        for (x = 0; x < 9; x++) {
            printf(" [");
            if (nanpleWork[x][y].hitno) {
                printf("%d        ", nanpleWork[x][y].hitno);
            } else {
                for (c = 1; c <= 9; c++) {
                    if (nanpleWork[x][y].checknolist[c]) {
                        printf("%d", c);
                    } else {
                        printf("x");
                    }
                }
            }
            printf("]");
            if ((x % 3) == 2)
                printf(" ");
        }
        printf("\n");
        if ((y % 3) == 2)
            printf("\n");
    }
    printf("\n");
}

/* ʂ̕\ */
void work_resultprint(void)
{
    int x, y, c;

    printf("𓚌:\n");
    for (y = 0; y < 9; y++) {
        for (x = 0; x < 9; x++) {
            printf("  %d", nanpleWork[x][y].hitno);
            if ((x % 3) == 2)
                printf(" ");
        }
        printf("\n");
        if ((y % 3) == 2)
            printf("\n");
    }
    printf("\n");
}


/* -------------------------------------------------------- */
int main(void)
{
    int x, y;
    
    /*  */
    init();
    
    do {
        for (y = 0; y < 9; y++) {
            for (x = 0; x < 9; x++) {
                /* Ֆʂ̂m肵Ă̂mF */
                item_set_checkno_fromareahitno(x, y);

                if (nanpleWork[x][y].hitno == 0) {
                    /* ̐i荞 */
                    /* cCC3x3̂ꂩ */
                    item_set_hitno_fromareacheckno(x, y);

                    /* m肵ǂmF */
                    item_check_checknolist(x, y);
                }
            }
        }
        work_dump();

        /* }X̐ɖoݒ肵̒l߂ */
        if (total_rulecheck()) {
            change_tmpno();
        }

        /* ՖʂɕωȂΉ̒l */
        if (!ischange()) {
            set_tmpno();
        }
    } while(!total_hitnocheck());
    work_resultprint();
    
    return 0;
}
